import { IFilteringExpressionsTree } from '../../data-operations/filtering-expressions-tree';
import { BaseFilteringStrategy } from '../../data-operations/filtering-strategy';
import { GridType } from '../common/grid.interface';
import { ITreeGridRecord } from './tree-grid.interfaces';
export declare class TreeGridFilteringStrategy extends BaseFilteringStrategy {
    filter(data: ITreeGridRecord[], expressionsTree: IFilteringExpressionsTree, advancedExpressionsTree?: IFilteringExpressionsTree, grid?: GridType): ITreeGridRecord[];
    protected getFieldValue(rec: any, fieldName: string, isDate?: boolean): any;
    private filterImpl;
}
export declare class TreeGridFormattedValuesFilteringStrategy extends TreeGridFilteringStrategy {
    private fields?;
    /**
     * Creates a new instance of FormattedValuesFilteringStrategy.
     *
     * @param fields An array of column field names that should be formatted.
     * If omitted the values of all columns which has formatter will be formatted.
     */
    constructor(fields?: string[]);
    /** @hidden */
    shouldApplyFormatter(fieldName: string): boolean;
    protected getFieldValue(rec: any, fieldName: string, isDate?: boolean, grid?: GridType): any;
}
